package cn.estsh.i3plus.pojo.mes.bean;


import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.io.Serializable;

/**
 * @Description :mes系统业务动作
 * @Reference :
 * @Author : jack.jia
 * @CreateDate : 2019-04-12
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_QC_ORDER_DETAIL")
@Api("MES_检验单明细")
public class MesQcOrderDetail extends BaseBean implements Serializable {
    private static final long serialVersionUID = -8961182786786500154L;
    @Column(name = "ORDER_NO")
    @ApiParam("质检单号")
    private String orderNo;

    @Column(name = "CHECK_TYPE")
    @ApiParam("检测类型")
    private Integer checkType;

    @Column(name = "CHECK_ITEM_TYPE")
    @ApiParam("检测项类型")
    private String checkItemType;

    @Column(name = "CHECK_ITEM")
    @ApiParam("检测项")
    private String checkItem;

    @Column(name = "CHECK_STANDARD")
    @ApiParam("检测标准")
    private String checkStandard;

    @Column(name = "CHECK_GUIDE")
    @ApiParam("检测指导")
    private String checkGuide;

    @Column(name = "CHECK_FREQUENCY")
    @ApiParam("频率")
    private String checkFrequency;

    @Column(name = "IS_CONCESSION")
    @ApiParam("是否允许让步")
    private String isConcession;

    @Column(name = "STATUS")
    @ApiParam("状态")
    private Integer status;

    @Column(name = "CHECK_RESULT")
    @ApiParam("检测整体结果")
    private Integer checkResult;

    @Column(name = "CHECK_VALUE")
    @ApiParam("检测值")
    private String checkValue;

    @Transient
    @ApiParam("本批次生产总数")
    private Integer currentLotNoSum;

    @Transient
    @ApiParam("收货批次")
    private String srcLotNo;
}
